## portaudio19 19.7.0+git20251227.3270c9ae

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(PortAudio VERSION 19.8)

#
# General PortAudio stuff
#

# Policy: By default, build PortAudio as a shared library.
# There are two ways to override the default behavior:
# 1. User can select shared or static PortAudio library build by explicitly defining PA_BUILD_SHARED_LIBS to ON or OFF (e.g. on the command line or an importing project)
# 2. If PA_BUILD_SHARED_LIBS is not set we respect the standard CMake BUILD_SHARED_LIBS variable if it is set.
if (NOT DEFINED PA_BUILD_SHARED_LIBS)
    if (DEFINED BUILD_SHARED_LIBS)
        set(PA_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})
    else()
        option(PA_BUILD_SHARED_LIBS "Build shared library" ON)
    endif()
endif()

option(PA_BUILD_TESTS "Include test projects" OFF)
option(PA_BUILD_EXAMPLES "Include example projects" OFF)

if(PA_BUILD_SHARED_LIBS)
  set(LIBRARY_BUILD_TYPE SHARED)
  message(STATUS "Build using a Portaudio SHARED (dynamic) libary.")
else()
  set(LIBRARY_BUILD_TYPE STATIC)
  message(STATUS "Build using a Portaudio STATIC libary.")
endif()

option(PA_WARNINGS_ARE_ERRORS "Turn compiler warnings into errors" OFF)
if(PA_WARNINGS_ARE_ERRORS)
    if(MSVC)
        add_compile_options(/WX
            # "Grandfathered" warnings that existed before we started enforcement.
            # Do *NOT* add warnings to this list. Instead, fix your code so that it doesn't produce the warning.
            # TODO: fix the offending code so that we don't have to exclude specific warnings anymore.
            /wd4244 # W2 conversion possible loss of data
            /wd4267 # W3 conversion possible loss of data
            /wd4996 # W3 unsafe/deprecated
        )
    else()
        add_compile_options(-Werror
            # "Grandfathered" warnings that existed before we started enforcement.
            # Do *NOT* add warnings to this list. Instead, fix your code so that it doesn't produce the warning.
            # TODO: fix the offending code so that we don't have to exclude specific warnings anymore.
            -Wno-error=deprecated-declarations  # https://github.com/PortAudio/portaudio/issues/213 https://github.com/PortAudio/portaudio/issues/641
            -Wno-error=stringop-overflow
        )
        if (CMAKE_C_COMPILER_ID MATCHES "Clang")
             # Don't fail on older clang versions that don't recognize the latest warnings in the list above.
             # Note that unrecognized warning options are not a fatal error on GCC, and in fact, GCC will choke on this option. Hence the conditional.
            add_compile_options(-Wno-error=unknown-warning-option)
        endif()
    endif()
endif()

add_library(portaudio
  ${LIBRARY_BUILD_TYPE}
  src/common/pa_allocation.c
  src/common/pa_allocation.h
  src/common/pa_converters.c
  src/common/pa_converters.h
  src/common/pa_cpuload.c
  src/common/pa_cpuload.h
  src/common/pa_debugprint.c
  src/common/pa_debugprint.h
  src/common/pa_dither.c
  src/common/pa_dither.h
  src/common/pa_endianness.h
  src/common/pa_front.c
  src/common/pa_hostapi.h
  src/common/pa_memorybarrier.h
  src/common/pa_process.c
  src/common/pa_process.h
  src/common/pa_ringbuffer.c
  src/common/pa_ringbuffer.h
  src/common/pa_stream.c
  src/common/pa_stream.h
  src/common/pa_trace.c
  src/common/pa_trace.h
  src/common/pa_types.h
  src/common/pa_util.h
)

include(GNUInstallDirs)

target_include_directories(portaudio PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/common>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)
if(UNIX)
  target_compile_options(portaudio PRIVATE -fPIC)
endif()

set(PORTAUDIO_PUBLIC_HEADERS include/portaudio.h)

find_package(Threads REQUIRED)
target_link_libraries(portaudio PRIVATE Threads::Threads)

option(PA_ENABLE_DEBUG_OUTPUT "Enable debug output for Portaudio" OFF)
if(PA_ENABLE_DEBUG_OUTPUT)
  target_compile_definitions(portaudio PRIVATE PA_ENABLE_DEBUG_OUTPUT)
endif()

include(TestBigEndian)
TEST_BIG_ENDIAN(IS_BIG_ENDIAN)
if(IS_BIG_ENDIAN)
  target_compile_definitions(portaudio PRIVATE PA_BIG_ENDIAN)
else()
  target_compile_definitions(portaudio PRIVATE PA_LITTLE_ENDIAN)
endif()

if(WIN32 AND MSVC AND PA_BUILD_SHARED_LIBS
  # Check if the user is building PortAudio stand-alone or as part of a larger
  # project. If this is part of a larger project (i.e. the CMakeLists.txt has
  # been imported by some other CMakeLists.txt), we don't want to override
  # that project's global settings.
  AND "${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_LIST_DIR}")
  option(PA_DLL_LINK_WITH_STATIC_RUNTIME
    "Link with static runtime libraries (minimizes runtime dependencies)" ON)
  if(PA_DLL_LINK_WITH_STATIC_RUNTIME)
    foreach(flag_var
      CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
      CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
      CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
      CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
    endforeach()
  endif()
endif()

#
# Host APIs
#

option(PA_USE_SKELETON "Use skeleton host API" OFF)
if(PA_USE_SKELETON)
  target_sources(portaudio PRIVATE src/hostapi/skeleton/pa_hostapi_skeleton.c)
  target_compile_definitions(portaudio PRIVATE PA_USE_SKELETON=1)
endif()

include(CMakeDependentOption)
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

# JACK is most commonly used on Linux, but it is cross platform, so allow building it on any OS
# if the FindJACK.cmake module finds POSIX headers.
find_package(JACK)
cmake_dependent_option(PA_USE_JACK "Enable support for JACK Audio Connection Kit" ON JACK_FOUND OFF)
if(PA_USE_JACK)
  target_link_libraries(portaudio PRIVATE JACK::jack)
  target_sources(portaudio PRIVATE
    src/hostapi/jack/pa_jack.c
    src/os/unix/pa_pthread_util.c
    src/os/unix/pa_pthread_util.h
  )
  set(PORTAUDIO_PUBLIC_HEADERS "${PORTAUDIO_PUBLIC_HEADERS}" include/pa_jack.h)
  target_include_directories(portaudio PRIVATE src/os/unix) # for pa_pthread_util.h
  target_compile_definitions(portaudio PUBLIC PA_USE_JACK=1)
  set(PKGCONFIG_CFLAGS "${PKGCONFIG_CFLAGS} -DPA_USE_JACK=1")
  set(PKGCONFIG_REQUIRES_PRIVATE "${PKGCONFIG_REQUIRES_PRIVATE} jack")

  # needed for PortAudioConfig.cmake so `find_package(PortAudio)` works in downstream projects
  install(FILES cmake/modules/FindRegex.cmake DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/portaudio/modules")
  install(FILES cmake/modules/FindJACK.cmake DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/portaudio/modules")
endif()

if(WIN32)
  target_sources(portaudio PRIVATE
    src/os/win/pa_win_coinitialize.c
    src/os/win/pa_win_coinitialize.h
    src/os/win/pa_win_hostapis.c
    src/os/win/pa_win_util.c
    src/os/win/pa_win_util.h
    src/os/win/pa_win_version.c
    src/os/win/pa_win_version.h
    src/os/win/pa_win_waveformat.c
    src/os/win/pa_win_wdmks_utils.h
    src/os/win/pa_x86_plain_converters.h
  )
  target_include_directories(portaudio PRIVATE src/os/win)
  set(PORTAUDIO_PUBLIC_HEADERS "${PORTAUDIO_PUBLIC_HEADERS}" include/pa_win_waveformat.h)
  target_link_libraries(portaudio PRIVATE winmm)

  if(MSVC)
    target_sources(portaudio PRIVATE src/os/win/pa_x86_plain_converters.c)
  else()
    target_compile_definitions(portaudio PRIVATE _WIN32_WINNT=0x0501 WINVER=0x0501)
    set(DEF_EXCLUDE_X86_PLAIN_CONVERTERS ";")
  endif()

  target_compile_definitions(portaudio PRIVATE _CRT_SECURE_NO_WARNINGS)

  option(PA_USE_ASIO "Enable support for ASIO" OFF)
  if(PA_USE_ASIO)
    find_package(ASIO)
    # Automatically download the ASIO SDK ZIP if it is not found. The ASIO SDK license
    # allows for downloading it from Steinberg and using it without charge, but it is
    # not allowed to be redistributed.
    #
    # The file(ARCHIVE_EXTRACT) command needed to extract the ZIP archive was added in
    # CMake 3.18, so do not bother downloading the ZIP archive for older CMake versions.
    # Instead, FindASIO.cmake directs the user to manually extract the ZIP file to
    # CMAKE_PREFIX_PATH or CMAKE_CURRENT_BINARY_DIR.
    if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.18 AND NOT TARGET ASIO::host)
      if(NOT ASIO_SDK_ZIP_PATH)
        set(ASIO_SDK_ZIP_PATH "${CMAKE_CURRENT_BINARY_DIR}/asiosdk.zip")
      endif()
      message(STATUS "Downloading ASIO SDK... ${ASIO_SDK_ZIP_PATH}")
      file(DOWNLOAD "https://www.steinberg.net/asiosdk"
        "${ASIO_SDK_ZIP_PATH}"
        STATUS ASIO_DOWNLOAD_STATUS
        SHOW_PROGRESS
      )
      if("${ASIO_DOWNLOAD_STATUS}" EQUAL 0)
        find_package(ASIO)
      else()
        list(GET "${ASIO_DOWNLOAD_STATUS}" 1 DOWNLOAD_ERROR)
        message(FATAL_ERROR "Error downloading ASIO SDK: ${DOWNLOAD_ERROR} "
          "Reconfigure CMake with -DPA_USE_ASIO=OFF to build without ASIO. "
          "Alternatively, download the ZIP from https://www.steinberg.net/asiosdk "
          "and put it in ${CMAKE_PREFIX_PATH} or ${CMAKE_CURRENT_BINARY_DIR}"
        )
      endif()
    endif()
  endif()
  if(PA_USE_ASIO AND TARGET ASIO::host)
    target_link_libraries(portaudio PRIVATE "$<BUILD_INTERFACE:ASIO::host>")
    set(PORTAUDIO_PUBLIC_HEADERS "${PORTAUDIO_PUBLIC_HEADERS}" include/pa_asio.h)
    target_compile_definitions(portaudio PUBLIC PA_USE_ASIO=1)
    set(PKGCONFIG_CFLAGS "${PKGCONFIG_CFLAGS} -DPA_USE_ASIO=1")
    target_sources(portaudio PRIVATE
      src/hostapi/asio/pa_asio.cpp
      src/hostapi/asio/iasiothiscallresolver.cpp
      src/hostapi/asio/iasiothiscallresolver.h
    )
  else()
    set(DEF_EXCLUDE_ASIO_SYMBOLS ";")
  endif()

  option(PA_USE_DS "Enable support for DirectSound" ON)
  if(PA_USE_DS)
    target_sources(portaudio PRIVATE
      src/hostapi/dsound/pa_win_ds.c
      src/hostapi/dsound/pa_win_ds_dynlink.c
      src/hostapi/dsound/pa_win_ds_dynlink.h
    )
    target_include_directories(portaudio PRIVATE src/hostapi/dsound)
    set(PORTAUDIO_PUBLIC_HEADERS "${PORTAUDIO_PUBLIC_HEADERS}" include/pa_win_ds.h)
    target_compile_definitions(portaudio PUBLIC PA_USE_DS=1)
    set(PKGCONFIG_CFLAGS "${PKGCONFIG_CFLAGS} -DPA_USE_DS=1")
    target_link_libraries(portaudio PRIVATE dsound)
    if(NOT MINGW)
      target_compile_definitions(portaudio PRIVATE PAWIN_USE_DIRECTSOUNDFULLDUPLEXCREATE)
    endif()
  endif()

  option(PA_USE_WMME "Enable support for WMME" ON)
  if(PA_USE_WMME)
    target_sources(portaudio PRIVATE src/hostapi/wmme/pa_win_wmme.c)
    set(PORTAUDIO_PUBLIC_HEADERS "${PORTAUDIO_PUBLIC_HEADERS}" include/pa_win_wmme.h)
    target_compile_definitions(portaudio PUBLIC PA_USE_WMME=1)
    set(PKGCONFIG_CFLAGS "${PKGCONFIG_CFLAGS} -DPA_USE_WMME=1")
    target_link_libraries(portaudio PRIVATE ole32 uuid)
  else()
    set(DEF_EXCLUDE_WMME_SYMBOLS ";")
  endif()

  option(PA_USE_WASAPI "Enable support for WASAPI" ON)
  if(PA_USE_WASAPI)
    target_sources(portaudio PRIVATE src/hostapi/wasapi/pa_win_wasapi.c)
    set(PORTAUDIO_PUBLIC_HEADERS "${PORTAUDIO_PUBLIC_HEADERS}" include/pa_win_wasapi.h)
    target_compile_definitions(portaudio PUBLIC PA_USE_WASAPI=1)
    set(PKGCONFIG_CFLAGS "${PKGCONFIG_CFLAGS} -DPA_USE_WASAPI=1")
    target_link_libraries(portaudio PRIVATE ole32 uuid)
  else()
    set(DEF_EXCLUDE_WASAPI_SYMBOLS ";")
  endif()

  option(PA_USE_WDMKS "Enable support for WDMKS" ON)
  if(PA_USE_WDMKS)
    target_sources(portaudio PRIVATE
      src/os/win/pa_win_wdmks_utils.c
      src/hostapi/wdmks/pa_win_wdmks.c
    )
    set(PORTAUDIO_PUBLIC_HEADERS "${PORTAUDIO_PUBLIC_HEADERS}" include/pa_win_wdmks.h)
    target_compile_definitions(portaudio PUBLIC PA_USE_WDMKS=1)
    set(PKGCONFIG_CFLAGS "${PKGCONFIG_CFLAGS} -DPA_USE_WDMKS=1")
    target_link_libraries(portaudio PRIVATE setupapi ole32 uuid)
  endif()

  option(PA_USE_WDMKS_DEVICE_INFO "Use WDM/KS API for device info" ON)
  if(PA_USE_WDMKS_DEVICE_INFO)
    target_compile_definitions(portaudio PRIVATE PAWIN_USE_WDMKS_DEVICE_INFO)
  endif()

=== qa/CMakeLists.txt ===
add_test(paqa_errs)
add_test(paqa_devs)
if(LINK_PRIVATE_SYMBOLS)
  add_test(paqa_dither)
endif()
add_test(paqa_latency)

subdirs(loopback)

=== test/CMakeLists.txt ===
# Test projects
# Use the macro to add test projects

add_test(pa_minlat)
add_test(patest1)
add_test(patest_buffer)
add_test(patest_callbackstop)
add_test(patest_clip)
if(LINK_PRIVATE_SYMBOLS)
  add_test(patest_converters)
endif()
add_test(patest_dither)
if(PA_USE_DS)
    add_test(patest_dsound_find_best_latency_params)
    add_test(patest_dsound_low_level_latency_params)
    add_test(patest_dsound_surround)
endif()
add_test(patest_hang)
add_test(patest_in_overflow)
if(PA_USE_WASAPI)
    add_test(patest_jack_wasapi)
    add_test(patest_wasapi_ac3)
    add_test(patest_wasapi_eac3)
    add_test(patest_read_write_wire_wasapi)
    add_test(patest_read_record_wasapi)
endif()
add_test(patest_latency)
add_test(patest_leftright)
add_test(patest_long_record)
add_test(patest_longsine)
add_test(patest_many)
add_test(patest_maxsines)
add_test(patest_mono)
add_test(patest_multi_sine)
add_test(patest_out_underflow)
add_test(patest_prime)
add_test(patest_read_record)
add_test(patest_ringmix)
add_test(patest_sine8)
add_test(patest_sine_channelmaps)
add_test(patest_sine_formats)
add_test(patest_sine_srate)
add_test(patest_sine_time)
add_test(patest_start_stop)
add_test(patest_stop)
add_test(patest_stop_playout)
add_test(patest_suggested_vs_streaminfo_latency)
if(LINK_PRIVATE_SYMBOLS)
  add_test(patest_sync)
endif()
add_test(patest_timing)
add_test(patest_toomanysines)
add_test(patest_two_rates)
add_test(patest_underflow)
add_test(patest_unplug)
add_test(patest_wire)
if(PA_USE_WMME)
    add_test(patest_wmme_find_best_latency_params)
    add_test(patest_wmme_low_level_latency_params)
endif()
add_test(patest_write_stop)
if(UNIX)
    add_test(patest_write_stop_hang_illegal)
endif()
add_test(patest_enumerate_default_latency)

=== test/test_use_cmake/CMakeLists.txt ===
# This test checks that it is possible to use the
# CMake artifacts generated by the build.

cmake_minimum_required(VERSION 3.1.0)
project(test_use)

file(GENERATE
  OUTPUT
    "${CMAKE_CURRENT_BINARY_DIR}/main.cpp"
  CONTENT
    [=[
#include <portaudio.h>
int main()
{
  Pa_Initialize();
  Pa_Terminate();
}
]=]
)

find_package(PortAudio REQUIRED)

add_library(test_use_static STATIC "${CMAKE_CURRENT_BINARY_DIR}/main.cpp")
add_library(test_use_shared SHARED "${CMAKE_CURRENT_BINARY_DIR}/main.cpp")
add_executable(test_use_exe "${CMAKE_CURRENT_BINARY_DIR}/main.cpp")

target_link_libraries(test_use_static PRIVATE portaudio)
target_link_libraries(test_use_shared PRIVATE portaudio)
target_link_libraries(test_use_exe PRIVATE portaudio)

=== debian/changelog ===
portaudio19 (19.7.0+git20251227.3270c9ae-0ubuntu1) resolute; urgency=medium

  * New upstream snapshot.
  * Refresh patches
  * Build-depend on autoconf-archive for AX_CHECK_COMPILE_FLAG
  * portaudio19-doc: remove deprecated pablio
  * Build with PulseAudio support
  * Add new PaPulseAudio_* symbols to libportaudio2
  * set PA_GIT_REVISION during build from Debian version

 -- Benjamin Drung <bdrung@ubuntu.com>  Wed, 07 Jan 2026 02:04:58 +0100

=== debian/control ===
Source: portaudio19
Priority: optional
Section: sound
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Kilian Krause <kilian@debian.org>,
           Mark Purcell <msp@debian.org>,
           Benjamin Drung <bdrung@debian.org>
Build-Depends: debhelper-compat (= 13),
               dpkg-dev (>= 1.13.19),
               autoconf-archive,
               automake,
               doxygen,
               libasound2-dev [linux-any],
               libjack-dev,
               libpulse-dev,
               pkgconf
Standards-Version: 4.7.2
Homepage: http://www.portaudio.com/
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/portaudio19
Vcs-Git: https://salsa.debian.org/pkg-voip-team/portaudio19.git

Package: libportaudio2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Portable audio I/O - shared library
 PortAudio is a portable audio I/O library designed for cross-platform
 support of audio. It uses a callback mechanism to request audio
 processing.  Audio can be generated in various formats, including 32
 bit floating point, and will be converted to the native format
 internally.
 .
 This package contains the shared library.

Package: libportaudiocpp0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Portable audio I/O C++ bindings - shared library
 PortAudio is a portable audio I/O library designed for cross-platform
 support of audio. It uses a callback mechanism to request audio
 processing.  Audio can be generated in various formats, including 32
 bit floating point, and will be converted to the native format
 internally.
 .
 This package contains the shared library of the C++ bindings.

Package: portaudio19-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libasound2-dev [linux-any],
         libjack-jackd2-dev | libjack-dev,
         libportaudio2 (= ${binary:Version}),
         libportaudiocpp0 (= ${binary:Version}),
         ${misc:Depends}
Suggests: portaudio19-doc
Conflicts: libportaudio-19-dev, libportaudio-dev, libportaudio19-dev
Replaces: libportaudio-19-dev, libportaudio19-dev
Description: Portable audio I/O - development files
 PortAudio is a portable audio I/O library designed for cross-platform
 support of audio. It uses a callback mechanism to request audio
 processing.  Audio can be generated in various formats, including 32
 bit floating point, and will be converted to the native format
 internally.
 .
 This package contains the development files.

Package: portaudio19-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, ${misc:Depends}
Description: Portable audio I/O - documentation
 PortAudio is a portable audio I/O library designed for cross-platform
 support of audio. It uses a callback mechanism to request audio
 processing.  Audio can be generated in various formats, including 32
 bit floating point, and will be converted to the native format
 internally.
 .
 This package contains the documentation.

## portaudio19 19.7.0+git20260206.e1b70d33

=== examples/CMakeLists.txt ===
# Example projects

macro(add_example appl_name)
  add_executable(${appl_name} "${appl_name}.c")
  target_link_libraries(${appl_name} portaudio)
  if(UNIX)
    target_link_libraries(${appl_name} m)
  endif()
  set_target_properties(${appl_name} PROPERTIES FOLDER "Examples C")
  if(WIN32)
    set_property(TARGET ${appl_name} APPEND_STRING PROPERTY COMPILE_DEFINITIONS _CRT_SECURE_NO_WARNINGS)
  endif()
endmacro()

macro(add_example_cpp appl_name)
  add_executable(${appl_name} "${appl_name}.cpp")
  target_link_libraries(${appl_name} portaudio)
  set_target_properties(${appl_name} PROPERTIES FOLDER "Examples C++")
  if(WIN32)
    set_property(TARGET ${appl_name} APPEND_STRING PROPERTY COMPILE_DEFINITIONS _CRT_SECURE_NO_WARNINGS)
  endif()
endmacro()

add_example(pa_devs)
add_example(pa_fuzz)
if(PA_USE_ASIO AND WIN32)
  add_example(paex_mono_asio_channel_select)
endif()
if(LINK_PRIVATE_SYMBOLS)
  add_example(paex_ocean_shore)
endif()
add_example(paex_pink)
add_example(paex_read_write_wire)
add_example(paex_record)
if(LINK_PRIVATE_SYMBOLS)
  add_example(paex_record_file)
endif()
add_example(paex_saw)
add_example(paex_sine)
add_example_cpp(paex_sine_c++)
if(PA_USE_WMME AND WIN32)
  add_example(paex_wmme_ac3)
  add_example(paex_wmme_surround)
endif()
add_example(paex_write_sine)
add_example(paex_write_sine_nonint)

=== qa/loopback/CMakeLists.txt ===
add_executable(paloopback
    src/audio_analyzer.c
    src/audio_analyzer.h
    src/biquad_filter.c
    src/biquad_filter.h
    src/paqa.c
    src/paqa_tools.c
    src/paqa_tools.h
    src/qa_tools.h
    src/test_audio_analyzer.c
    src/test_audio_analyzer.h
    src/write_wav.c
    src/write_wav.h
)
target_include_directories(paloopback PRIVATE ..)
target_link_libraries(paloopback portaudio)
if(UNIX)
  target_link_libraries(paloopback m)
endif()

=== debian/changelog ===
portaudio19 (19.7.0+git20260206.e1b70d33-0ubuntu1) resolute; urgency=medium

  * New upstream snapshot.

 -- Benjamin Drung <bdrung@ubuntu.com>  Fri, 06 Feb 2026 00:38:48 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --no-parallel

override_dh_auto_clean:
	dh_auto_clean
	./clear_gitrevision.sh
	[ ! -f bindings/cpp/Makefile ] || $(MAKE) distclean -C bindings/cpp
	rm -f bindings/cpp/doc/Makefile doc/html/*

override_dh_auto_configure:
	# autoreconf again to work around autoconf weirdness, cf. debbug#997360
	# and https://bugzilla.redhat.com/show_bug.cgi?id=1943118
	autoreconf -i -f
	echo "#define PA_GIT_REVISION $(shell echo $(DEB_VERSION_UPSTREAM) | sed "s/.*\.//")" > src/common/pa_gitrevision.h
	dh_auto_configure -- --enable-cxx -with-pic=yes

override_dh_auto_build:
	dh_auto_build
	doxygen
